# cs_image_store – Manages CloudStack Image Stores

New in version 2.8.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Deploy, remove, recreate CloudStack Image Stores.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- cs >= 0.6.10

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

api_http_method
string

Choices:
- get
- post

HTTP method used to query the API endpoint.
If not given, the `CLOUDSTACK_METHOD` env variable is considered.
As the last option, the value is taken from the ini config file, also see the notes.
Fallback value is `get` if not specified.

api_key string |  | API key of the CloudStack API. If not given, the `CLOUDSTACK_KEY` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_region string | Default: "cloudstack" | Name of the ini section in the `cloustack.ini` file. If not given, the `CLOUDSTACK_REGION` env variable is considered.
api_secret string |  | Secret key of the CloudStack API. If not set, the `CLOUDSTACK_SECRET` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_timeout integer |  | HTTP timeout in seconds. If not given, the `CLOUDSTACK_TIMEOUT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes. Fallback value is 10 seconds if not specified.
api_url string |  | URL of the CloudStack API e.g. https://cloud.example.com/client/api. If not given, the `CLOUDSTACK_ENDPOINT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.

force_recreate
boolean

Choices:
- no ←
- yes

Set to `yes` if you're changing an existing Image Store.
This will force the recreation of the Image Store.
Recreation might fail if there are snapshots present on the Image Store. Delete them before running the recreation.

name string / required |  | The ID of the Image Store. Required when deleting a Image Store.
provider string |  | The image store provider name. Required when creating a new Image Store

state
string

Choices:
- present ←
- absent

Stage of the Image Store

url string |  | The URL for the Image Store. Required when state=present.
zone string / required |  | The Zone name for the Image Store.

## Notes

Note

- Ansible uses the `cs` library’s configuration method if credentials are not provided by the arguments `api_url`, `api_key`, `api_secret`. Configuration is read from several locations, in the following order. The `CLOUDSTACK_ENDPOINT`, `CLOUDSTACK_KEY`, `CLOUDSTACK_SECRET` and `CLOUDSTACK_METHOD`. `CLOUDSTACK_TIMEOUT` environment variables. A `CLOUDSTACK_CONFIG` environment variable pointing to an `.ini` file. A `cloudstack.ini` file in the current working directory. A `.cloudstack.ini` file in the users home directory. Optionally multiple credentials and endpoints can be specified using ini sections in `cloudstack.ini`. Use the argument `api_region` to select the section name, default section is `cloudstack`. See https://github.com/exoscale/cs for more information.
- A detailed guide about cloudstack modules can be found in the CloudStack Cloud Guide.
- This module supports check mode.

## Examples

    - name: Add a Image Store (NFS)
      cs_image_store:
        zone: zone-01
        name: nfs-01
        provider: NFS
        url: nfs://192.168.21.16/exports/secondary
      delegate_to: localhost

    # Change the NFS share URL and force a Image Store recreation
    - name: Change the NFS url
      cs_image_store:
        zone: zone-01
        name: nfs-01
        provider: NFS
        force_recreate: yes
        url: nfs://192.168.21.10/shares/secondary
      delegate_to: localhost

    - name: delete the image store
      cs_image_store:
        name: nfs-01
        zone: zone-01
        state: absent
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
id string | success | the ID of the image store Sample: feb11a84-a093-45eb-b84d-7f680313c40b
name string | success | the name of the image store Sample: nfs-01
protocol string | success | the protocol of the image store Sample: nfs
provider_name string | success | the provider name of the image store Sample: NFS
scope string | success | the scope of the image store Sample: ZONE
url string | success | the url of the image store Sample: nfs://192.168.21.16/exports/secondary
zone string | success | the Zone name of the image store Sample: zone-01

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Patryk Cichy (@PatTheSilent)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.